From 42c6fc60998954feb577300f1d35a749bf26a008 Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 13/48] Convert ModuleProfile to libmodulemd


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index 3f3ee5b..a2a390c 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -685,9 +685,11 @@ class ModuleMetadata(object):
     def profiles(self):
         """A dictionary property representing the module profiles."""
         # TODO: return the profiles as a dict of ModuleProfile types
-        return {}
+        d = dict()
+        for k,v in self.module.get_profiles().items():
+            d[k] = ModuleProfile(profile=v, parent=self, name=k)
 
-        return self._profiles
+        return d
 
     @profiles.setter
     def profiles(self, d):
@@ -696,7 +698,20 @@ class ModuleMetadata(object):
         for k, v in d.items():
             if not isinstance(k, str) or not isinstance(v, ModuleProfile):
                 raise TypeError("profiles: data type not supported")
-        self._profiles = d
+
+        profiles = self.module.get_profiles()
+
+        for k,v in d.items():
+            profile = Modulemd.Profile()
+            if v.description:
+                profile.set_description(v.description)
+
+            ss = Modulemd.SimpleSet()
+            ss.set(list(v.rpms))
+
+            profile.set_rpms(ss)
+            profiles[k] = profile
+        self.module.set_profiles(profiles)
 
     @property
     def api(self):
diff --git a/modulemd/profile.py b/modulemd/profile.py
index 254ff76..9e2d2ad 100644
--- a/modulemd/profile.py
+++ b/modulemd/profile.py
@@ -25,13 +25,25 @@
 
 supported_content = ( "rpms", )
 
+from gi.repository import Modulemd
+
 class ModuleProfile(object):
     """Class representing a particular module profile."""
 
-    def __init__(self):
+    def __init__(self, profile=None, name=None, parent=None):
         """Creates a new ModuleProfile instance."""
-        self.description = ""
-        self.rpms = set()
+        if profile:
+            if isinstance(profile, Modulemd.Profile):
+                self.profile = profile
+            else:
+                raise TypeError("Supplied value is not a profile")
+        else:
+            self.profile = Modulemd.Profile()
+
+        if parent:
+            self.parent = parent
+        if name:
+            self.name = name
 
     def __repr__(self):
         return ("<ModuleProfile: "
@@ -50,18 +62,22 @@ class ModuleProfile(object):
     def description(self):
         """A string property representing a detailed description of the
         profile."""
-        return self._description
+        return self.profile.get_description()
 
     @description.setter
     def description(self, s):
         if not isinstance(s, str):
             raise TypeError("profile.description: data type not supported")
-        self._description = s
+        self.profile.set_description(s)
+        if hasattr(self, 'parent') and hasattr(self, 'name'):
+            profiles = self.parent.module.get_profiles()
+            profiles[self.name] = self.profile
+            self.parent.module.set_profiles(profiles)
 
     @property
     def rpms(self):
         """A set of binary RPM packages included in this profile."""
-        return self._rpms
+        return set(sorted(self.profile.get_rpms().get()))
 
     @rpms.setter
     def rpms(self, ss):
@@ -70,7 +86,15 @@ class ModuleProfile(object):
         for v in ss:
             if not isinstance(v, str):
                 raise TypeError("profile.rpms: data type not supported")
-        self._rpms = ss
+
+        simpleset = Modulemd.SimpleSet()
+        simpleset.set(list(ss))
+        self.profile.set_rpms(simpleset)
+
+        if hasattr(self, 'parent') and hasattr(self, 'name'):
+            profiles = self.parent.module.get_profiles()
+            profiles[self.name] = self.profile
+            self.parent.module.set_profiles(profiles)
 
     def add_rpm(self, s):
         """Adds a binary RPM package to the profile set.
@@ -79,7 +103,14 @@ class ModuleProfile(object):
         """
         if not isinstance(s, str):
             raise TypeError("profile.add_rpm: data type not supported")
-        self._rpms.add(s)
+        simpleset = self.profile.get_rpms()
+        simpleset.add(s)
+        self.profile.set_rpms(simpleset)
+
+        if hasattr(self, 'parent') and hasattr(self, 'name'):
+            profiles = self.parent.module.get_profiles()
+            profiles[self.name] = self.profile
+            self.parent.module.set_profiles(profiles)
 
     def del_rpm(self, s):
         """Removes the supplied package name from the profile package set.
@@ -88,8 +119,20 @@ class ModuleProfile(object):
         """
         if not isinstance(s, str):
             raise TypeError("profile.del_rpm: data type not supported")
-        self._rpms.discard(s)
+        simpleset = self.profile.get_rpms()
+        simpleset.remove(s)
+        self.profile.set_rpms(simpleset)
+
+        if hasattr(self, 'parent') and hasattr(self, 'name'):
+            profiles = self.parent.module.get_profiles()
+            profiles[self.name] = self.profile
+            self.parent.module.set_profiles(profiles)
 
     def clear_rpms(self):
         """Clear the profile binary RPM package set."""
-        self._rpms.clear()
+        self.profile.set_rpms(Modulemd.SimpleSet())
+
+        if hasattr(self, 'parent') and hasattr(self, 'name'):
+            profiles = self.parent.module.get_profiles()
+            profiles[self.name] = self.profile
+            self.parent.module.set_profiles(profiles)

